<?php
/*
 * @Author: Qinver
 * @Url: zibll.com
 * @Date: 2021-01-23 15:30:33
 * @LastEditTime: 2021-01-25 13:20:40
 */


//ajax导入
function zib_cp_ajax_add_cardcode()
{

    if (empty($_POST['post_id'])) {
        echo (json_encode(array('error' => 1, 'ys' => 'danger', 'msg' => '文章参数为空')));
        exit();
    }
    if (empty($_POST['cardcode'])) {
        echo (json_encode(array('error' => 1, 'ys' => 'danger', 'msg' => '请输入卡密内容')));
        exit();
    }

    $add = zib_cp::add($_POST['post_id'], $_POST['cardcode']);
    if (!empty($add['cardcode'])) {
        echo (json_encode(array('error' => 0, 'ys' => 'danger', 'cardcode' => $add['cardcode'], 'msg' => '成功添加' . $add['add_count'] . '个数据')));
    } else {
        echo (json_encode(array('error' => 1, 'ys' => 'danger', 'msg' => '数据添加失败！')));
    }

    exit();
}
add_action('wp_ajax_add_cardcode', 'zib_cp_ajax_add_cardcode');


//ajax删除
function zib_cp_ajax_del_cardcode()
{

    if (empty($_POST['post_id'])) {
        echo (json_encode(array('error' => 1, 'ys' => 'danger', 'msg' => '文章参数为空')));
        exit();
    }
    if (empty($_POST['delete'])) {
        echo (json_encode(array('error' => 1, 'ys' => 'danger', 'msg' => '未选择删除内容')));
        exit();
    }

    $delete = zib_cp::delete($_POST['post_id'], $_POST['delete']);
    if (!empty($delete['delete'])) {
        echo (json_encode(array('error' => 0, 'ys' => 'danger', 'delete' => $delete['delete'], 'msg' => '成功删除' . $delete['count'] . '个数据')));
    } else {
        echo (json_encode(array('error' => 1, 'ys' => 'danger', 'msg' => '内容删除失败')));
    }

    exit();
}
add_action('wp_ajax_del_cardcode', 'zib_cp_ajax_del_cardcode');


//购买成功之后为用户下发卡密
add_action('payment_order_success', 'zib_cp_add_user_cardcode');
function zib_cp_add_user_cardcode($values)
{
    $pay_order = (array) $values;
    $post_id = $pay_order['post_id'];
    $order_type = $pay_order['order_type'];
    //判断订单类型
    if ($order_type != 7) return;
    $order_num = $pay_order['order_num'];
    if (!isset($pay_order['cardcode'])) {
        global $wpdb;
        // 判断数据库推荐返利功能字段，无则添加
        if (!$wpdb->get_row("SELECT column_name FROM information_schema.columns WHERE table_name='$wpdb->zibpay_order' and column_name ='cardcode'")) {
            @$wpdb->query("ALTER TABLE $wpdb->zibpay_order ADD cardcode longtext DEFAULT null COMMENT '卡密'");
        }
    }

    //避免重复
    if (!empty($pay_order['cardcode'])) return;

    //执行下发卡密
    zib_cp::user_add($post_id, $order_num);
}

//用户中心AJAX获取卡密信息
function zib_cp_ajax_show_author_tab_cardcode()
{
    $con = '';
    $con .=  zib_cp_user_cardcode_lists();
    $con .= '<div class="ajax-pag hide"><div class="next-page ajax-next"><a href="#"></a></div></div>';
    echo '<body><main><div class="ajaxpager">' . $con . '</div></main></body>';
    exit;
}
add_action('wp_ajax_author_tab_cardcode', 'zib_cp_ajax_show_author_tab_cardcode');

//文章内AJAX获取用户卡密信息
function zib_cp_ajax_show_post_user_cardcode()
{
    $con = '';
    $con .= zib_cp_post_user_cardcode_lists();
    $con .= '<div class="ajax-pag hide"><div class="next-page ajax-next"><a href="#"></a></div></div>';
    echo '<body><main><div class="ajaxpager">' . $con . '</div></main></body>';
    exit;
}
add_action('wp_ajax_post_user_cardcode', 'zib_cp_ajax_show_post_user_cardcode');


//卡密发放成功为用户推送消息及邮件
add_action('add_cardcode_success', 'zib_cp_add_cardcode_msg');
function zib_cp_add_cardcode_msg($values)
{
    /**根据订单号查询订单 */
    $order = (array) $values;

    $cp_data = maybe_unserialize($order['cardcode']);

    //没有卡密则退出
    if (empty($cp_data['code'])) return;

    ///标题
    $blog_name = get_bloginfo('name');
    $m_title = '卡密购买成功！请查收您的卡密信息';
    $title = '[' . $blog_name . '] ' . $m_title;

    //用户id
    $user_id = $order['user_id'];

    //用户邮箱
    $udata = get_userdata($user_id);
    $user_name = !empty($udata->display_name) ? $udata->display_name : '';
    /**获取用户邮箱 */
    $user_email = !empty($udata->user_email) ? $udata->user_email : '';

    //文章ID
    $post_id = $order['post_id'];
    //时间
    $pay_time = '购买时间：' . $order['pay_time'];

    $cp_code = '<b data-clipboard-text="' . $cp_data['code'] . '" style="color: #2997f7;background: rgba(41, 151, 247, 0.11);padding: 8px 15px;border-radius: 4px;margin-right: 10px;">卡号：' . $cp_data['code'] . '</b>';
    $cp_key = $cp_data['key'] ? '<b data-clipboard-text="' . $cp_data['key'] . '" style="color: #f75929;background: rgba(247, 128, 41, 0.1);padding: 8px 15px;border-radius: 4px;margin-right: 10px;">卡密：' . $cp_data['key'] . '</b>' : '';

    $posts_title = get_the_title($post_id);
    $pay_title = '<a style="color: #f73d2a;" target="_blank" href="' . get_permalink($post_id) . '">' . $posts_title . '</a>';

    $message = '您好！ ' . $user_name . "<br />";
    $message .= '您的卡密购买成功！请查收您的卡密信息，如遗失卡密信息，您还可进入本站用户中心查看！' . "<br />";
    $message .= $cp_code . $cp_key . "<br /><br />";

    $message .= '您可以点击下方链接查看商品详情！' . "<br />";
    $message .= $pay_title . "<br />";
    $message .= $pay_time;

    $msg_arge = array(
        'send_user' => 'admin',
        'receive_user' => $user_id,
        'type' => 'pay',
        'title' => $m_title,
        'content' => $message,
        'meta' => '',
        'other' => '',
    );
    //创建新消息
    if (_pz('message_s', true)) {
        ZibMsg::add($msg_arge);
    }

    /**发送邮件 */
    @wp_mail($user_email, $title, $message);
}


//缺少库存时候为管理员发送邮件
add_action('add_cardcode_success', 'zib_cp_lack_cardcode_email_admin');
function zib_cp_lack_cardcode_email_admin($values)
{
    $pay_order = (array) $values;
    $post_id = $pay_order['post_id'];
    $cp_count = zib_cp::count($post_id, 'valid');

    if ($cp_count > 5) return;

    $posts_title = get_the_title($post_id);
    $title = '卡密库存不足，仅剩' . $cp_count . '个！请及时补充：商品[' . zib_str_cut($posts_title, 0, 15) . ']';

    $edit_url = add_query_arg(array('post' => $post_id, 'action' => 'edit'), admin_url('post.php'));
    $message = '您的卡密商品[' . $posts_title . ']<br />库存已经不足，请您及时补充或做其它处理！ ' . "<br /><br />";

    $message .= '卡密商品：<a target="_blank" href="' . get_permalink($post_id) . '">' . $posts_title . '</a>' . "<br /><br />";
    $message .= '当前库存：<b style="color:#ff4d6f;font-size: 30px;">' . $cp_count . '</b>' . "<br /><br />";
    $message .= '您可以点击下方链接以添加库存或者管理此商品' . "<br />";
    $message .= '<a target="_blank" href="' . esc_url($edit_url) . '"></a>' . $edit_url . "<br />";

    $blog_name = get_bloginfo('name');
    $title = '[' . $blog_name . '] ' . $title;

    /**发送邮件 */
    @wp_mail(get_option('admin_email'), $title, $message);
}
