<?php
/*
 * @Author: Qinver
 * @Url: zibll.com
 * @Date: 2020-12-21 22:54:02
 * @LastEditTime: 2021-01-23 13:35:23
 */


if (!is_super_admin()) {
     wp_die('您不能访问此页面', '权限不足');
     exit;
}

$this_url = esc_url(admin_url('admin.php?page=zibpay_api'));
$tab = !empty($_GET['tab']) ? $_GET['tab'] : '';
$action = !empty($_REQUEST['action']) ? $_REQUEST['action'] : '';
$s = !empty($_REQUEST['s']) ? esc_sql($_REQUEST['s']) : '';

if ($action) {
     switch ($action) {
          case 'delete':
               $order_num = !empty($_REQUEST['order_num']) ? (int)$_REQUEST['order_num'] : 0;
               if (!$order_num) {
                    zib_cp_admin_page_notice('错误！', '参数传入错误', 'error');
                    break;
               }

               if ($delete) {
                    zib_cp_admin_page_notice('删除成功！', '授权信息已删除');
               } else {
                    zib_cp_admin_page_notice('已删除', '',  'warning');
               }
               break;

          case 'add_msg':

               $tab = '';
               break;
     }
}

function zib_cp_admin_page_notice($title = '', $msg = '', $type = 'success')
{
     $html = '';
     $html .= $title ? '<h3>' . $title . '</h3>' : '';
     $html .= $msg ? '<p>' . $msg . '</p>' : '';
     if ($html) {
          echo '<div class="notice notice-' . $type . '">' . $html . '</div>';
     }
}

$page_title = 'zibll授权明细';
$head_but = '';
$sub_but = array();


//准备查询参数
$msg_type = !empty($_REQUEST['msg_type']) ? $_REQUEST['msg_type'] : 0;
$user_id = !empty($_REQUEST['user_id']) ? $_REQUEST['user_id'] : 0;
$orderby = !empty($_REQUEST['orderby']) ? $_REQUEST['orderby'] : 'pay_time';
$paged = !empty($_REQUEST['paged']) ? $_REQUEST['paged'] : 1;
$ice_perpage = !empty($_REQUEST['ice_perpage']) ? $_REQUEST['ice_perpage'] : 15;
$desc = !empty($_REQUEST['desc']) ? $_REQUEST['desc'] : 'DESC';
$offset = $ice_perpage * ($paged - 1);

$count_all = 0;
$db_msg = false;
$csf_args = false;
$table = false;
$pagenavi = false;
$search = false;
$page_html = false;


if ($tab == 'manage') {
} elseif ($tab == 'new') {
} else {
     $pagenavi = true;
     if ($s)  $head_but .= '<div><div class="update-nag" style="margin: 10px 0 0;">搜索 “' . $s . '” 的内容 </div></div>';

     global $wpdb;
     $desc = $desc == 'DESC' ? 'DESC' : '';
     $where_s = $s ? " AND (`order_num` LIKE '%$s%' OR `pay_num` LIKE '%$s%' OR `aut_info` LIKE '%$s%' )" : '';

     $where = "`status` = 1 and `order_type` = 3 and `aut_info` IS NOT NULL $where_s";
     $sql = "SELECT * FROM {$wpdb->zibpay_order} WHERE $where order by $orderby $desc limit $offset,$ice_perpage";
     $db_list = $wpdb->get_results($sql);
     $sql = "SELECT COUNT(id) FROM {$wpdb->zibpay_order} WHERE $where";
     $count_all = $wpdb->get_var($sql);

     $table = '<thead><tr><td style="color: #ff4a4a;text-align: center;">未找到对应消息，或暂无消息</td></tr></thead>';
     if ($db_list) {
          $table = '';

          $theads[] = array('width' => '7%', 'orderby' => 'order_num', 'name' => '订单号');
          $theads[] = array('width' => '5%', 'orderby' => '', 'name' => '商品');
          $theads[] = array('width' => '5%', 'orderby' => 'pay_price', 'name' => '订单金额');
          $theads[] = array('width' => '5%', 'orderby' => 'user_id', 'name' => '用户');
          $theads[] = array('width' => '8%', 'orderby' => 'pay_time', 'name' => '支付时间');
          $theads[] = array('width' => '5%', 'orderby' => '', 'name' => '最多授权');
          $theads[] = array('width' => '15%', 'orderby' => '', 'name' => '已授权');
          $theads[] = array('width' => '15%', 'orderby' => '', 'name' => '授权码');

          $thead_th = '';
          foreach ($theads as $thead) {
               $orderby = '';
               if ($thead['orderby']) {
                    $orderby_url = add_query_arg('orderby', $thead['orderby']);
                    $orderby .= '<a title="降序" href="' . add_query_arg('desc', 'ASC', $orderby_url) . '"><span class="dashicons dashicons-arrow-up"></span></a>';
                    $orderby .= '<a title="升序" href="' . add_query_arg('desc', 'DESC', $orderby_url) . '"><span class="dashicons dashicons-arrow-down"></span></a>';
                    $orderby = '<span class="orderby-but">' . $orderby . '</span>';
               }
               $thead_th .= '<th class="" width="' . $thead['width'] . '">' . $thead['name'] . $orderby . '</th>';
          }
          $table .= '<thead><tr>' . $thead_th . '</tr></thead>';

          $tbody = '';
          foreach ($db_list as $value) {
               $edit = '<a class="" onclick="return confirm(\'确认删除此授权信息?  删除后数据不可恢复!\')" href="' . add_query_arg(array('action' => 'delete', 'order_num' => $value->order_num)) . '">删除</a>';

               $user_a = '<a target="_blank" href="' . add_query_arg('page', 'pay_theme', get_author_posts_url($value->user_id)) . '">' . get_the_author_meta('display_name', $value->user_id) . '</a>';
               $order_num = '<a href="' . add_query_arg('s', $value->order_num, admin_url('admin.php?page=zibpay_order_page')) . '">' . $value->order_num . '</a>';

               $aut_info = !empty($value->aut_info) ?  maybe_unserialize($value->aut_info) : '';
               $authorization_code = !empty($aut_info['authorization_code']) ? $aut_info['authorization_code'] : '';
               if ($authorization_code) {
                    $authorization_code = '<a target="_blank" href="' . add_query_arg('s', $authorization_code, 'https://api.zibll.com/wp-admin/admin.php?page=zibllAuthorization%2Fadmin%2Fpage%2Forder_details.php') . '">' . $authorization_code . '</a>';
               }
               $product_name_code = !empty($aut_info['product_name_code']) ? $aut_info['product_name_code'] : '';
               if ($authorization_code) {
                    $product_name_code = '<a target="_blank" href="https://api.zibll.com/wp-admin/admin.php?page=zibllAuthorization%2Fadmin%2Fpage%2Fproduct_details.php">' . $product_name_code . '</a>';
               }
               $aut_url = '';

               $max = $value->aut_max_url;
               $tbody .= "<tr>\n";
               $tbody .= "<td>$order_num<div class='row-actions'>$edit</div></td>\n";
               $tbody .= "<td>$product_name_code</td>\n";
               $tbody .= "<td>$value->pay_price</td>\n";
               $tbody .= "<td>$user_a</td>\n";
               $tbody .= "<td>$value->pay_time</td>\n";
               $tbody .= "<td>$max</td>\n";
               $tbody .= "<td>$aut_url</td>\n";
               $tbody .= "<td>$authorization_code</td>\n";
               // $aut_info  = json_encode($aut_info);
               // $tbody .= "<td>$aut_info</td>\n";
               $tbody .= "</tr>";
               // echo json_encode($value);
          }
          $table .= '<tbody>' . $tbody . '</tbody>';
     }

     $search = '<form class="form-inline form-order" method="post">
                    <div class="form-group" style="float: right;">
                        <input type="text" class="form-control" name="s" placeholder="搜索">
                        <button type="submit" class="button">提交</button>
                    </div>
                </form>';
}


?>
<div class="wrap">
     <h1 class="wp-heading-inline"><?php echo $page_title; ?></h1>
     <?php echo $head_but; ?>
     <?php
     if ($sub_but) {
          $but_html = '';
          foreach ($sub_but as $but) {
               $but_html .= '<li><a href="' . $but['href'] . '">' . $but['name'] . '</a></li> | ';
          }
          if ($but_html) {
               echo '<div class="order-header"><ul class="subsubsub">' . substr($but_html, 0, -2) . '</ul></div>';
          }
     };

     if ($search) {
          echo $search;
     }
     if ($table) {
          echo '<p class="search-box">';
          echo '<div style="overflow-y: auto;width: 100%;">';
          echo '<table class="widefat fixed striped posts table table-bordered" style="min-width: 1000px;">';
          echo $table;
          echo '</table>';
          echo '</div>';
          echo '</p><div class="clear"></div>';
     }
     if ($page_html) {
          echo $page_html;
     }
     if ($pagenavi) {
          zibpay_admin_pagenavi($count_all, $ice_perpage);
     }

     ?>


</div>