<?php
/*
 * @Author: Qinver
 * @Url: zibll.com
 * @Date: 2021-01-23 13:01:32
 * @LastEditTime: 2021-01-24 23:32:37
 */

$functions = array(
    'class/cardcode',
    'user',
    'action',
    'pay',
);

foreach ($functions as $function) {
    require_once plugin_dir_path(__FILE__) . $function . '.php';
}


add_action('admin_enqueue_scripts', 'zib_cp_admin_scripts');
function zib_cp_admin_scripts()
{
    wp_enqueue_style('zib_cp_main', ZIB_CP_URL . '/includes/assets/css/main.min.css');
    wp_enqueue_script('zib_cp_main', ZIB_CP_URL . '/includes/assets/js/main.min.js', array('jquery'), '', true);
    wp_localize_script('zib_cp_main', 'wp_ajax_url', admin_url("admin-ajax.php"));
}

//为付费内容添加选项
function zib_cp_add_meta_box_args($args)
{
    $post_id = !empty($_GET['post']) ? $_GET['post'] : '';
    $args[0]['options'][7] = '自动售卡';

    if (!$post_id) {
        $args[] = array(
            'dependency' => array('pay_type', '==', '7'),
            'type'       => 'accordion',
            'id'       => 'accordion',
            'accordions' => array(
                array(
                    'title'  => '卡密管理',
                    'icon'   => 'fas fa-star',
                    'fields' => array(
                        array(
                            'type'    => 'content',
                            'content' => '<div style="color:#fb2121;text-align: center;padding: 10px;">请保存文章后，在此管理卡密信息</div>'
                        )
                    )
                )
            )
        );
    } else {
        $args[] = array(
            'dependency' => array('pay_type', '==', '7'),
            'type'       => 'accordion',
            'id'       => 'accordion',
            'accordions' => array(
                array(
                    'title'  => '卡密管理',
                    'icon'   => 'fas fa-star',
                    'fields' => array(
                        array(
                            'type'          => 'tabbed',
                            'id'            => 'theme_text',
                            'tabs'          => array(
                                array(
                                    'title'     => '卡密列表',
                                    'icon'      => 'fa fa-file-text-o fa-fw',
                                    'fields'    => array(
                                        array(
                                            'type'    => 'content',
                                            'content' => zib_cp_post_key_list($post_id)
                                        )
                                    ),
                                ),
                                array(
                                    'title'     => '添加卡密',
                                    'icon'      => 'fa fa-cloud-upload fa-fw',
                                    'fields'    => array(
                                        array(
                                            'type'    => 'content',
                                            'content' => zib_cp_post_add_key($post_id)
                                        )
                                    ),
                                ),
                            )
                        )
                    )
                ),
            )
        );
    }

    return $args;
}

//添加文章付费参数
add_filter('zib_add_pay_meta_box_args', 'zib_cp_add_meta_box_args');

function zib_cp_post_key_list($post_id)
{
    $date = zib_cp::get($post_id);
    $all_count = '<span style="padding: 1px 10px;min-width: auto;" class="but b-yellow">全部 ' . zib_cp::count($post_id, 'all') . '</span>';
    $pay_count = '<span style="padding: 1px 10px;min-width: auto;" class="but b-red">已售 ' . zib_cp::count($post_id, 'invalid') . '</span>';
    $valid_count = '<span style="padding: 1px 10px;min-width: auto;" class="but b-blue">库存 ' . zib_cp::count($post_id, 'valid') . '</span>';

    if (!$date) {
        return '<div style="color:#fb2121;text-align: center;padding: 10px;">暂无卡密信息，请添加！</div>';
    }

    $html = '';
    $html .= '<p>';
    $html .= $all_count . $valid_count . $pay_count;
    $html .= '</p>';


    $table = zib_cp_post_key_table($post_id);
    $html .= '<div style="overflow-y: auto;width: 100%;">';
    $html .= '<table class="widefat fixed striped posts table table-bordered" style="min-width:600px;">';
    $html .= $table;
    $html .= '</table>';
    $html .= '</div>';
    //   $html .= json_encode($date);

    return $html;
}


function zib_cp_post_key_table($post_id, $show_check = false)
{
    $date = zib_cp::get($post_id);

    $table = '';
    if ($date) {
        $theads[] = array('width' => '25%', 'orderby' => '', 'name' => '卡号');
        $theads[] = array('width' => '25%', 'orderby' => '', 'name' => '密码');
        $theads[] = array('width' => '15%', 'orderby' => '', 'name' => '状态');
        $theads[] = array('width' => '15%', 'orderby' => '', 'name' => '创建时间');
        $theads[] = array('width' => '15%', 'orderby' => '', 'name' => '售出时间');

        $thead_th = '';
        $thead_th .=  $show_check ? '<th class="check-column"><input type="checkbox" class="check-all"></th>' : '';

        foreach ($theads as $thead) {
            $orderby = '';
            if ($thead['orderby']) {
                $orderby_url = add_query_arg('orderby', $thead['orderby']);
                $orderby .= '<a title="降序" href="' . add_query_arg('desc', 'ASC', $orderby_url) . '"><span class="dashicons dashicons-arrow-up"></span></a>';
                $orderby .= '<a title="升序" href="' . add_query_arg('desc', 'DESC', $orderby_url) . '"><span class="dashicons dashicons-arrow-down"></span></a>';
                $orderby = '<span class="orderby-but">' . $orderby . '</span>';
            }
            $thead_th .= '<th class="" width="' . $thead['width'] . '">' . $thead['name'] . $orderby . '</th>';
        }
        $table .= '<thead><tr>' . $thead_th . '</tr></thead>';

        $tbody = '';
        foreach ($date as $key => $value) {
            $tbody .= '<tr data-key="' . $key . '" >';
            $value = zib_cp::map($value);

            $status =  zib_cp::status_name($value['status']);
            if (!empty($value['order'])) {
                $url = admin_url('admin.php?page=zibpay_order_page&s=' . $value['order']);
                $status .= '<a style="padding: 1px 10px;min-width: auto;" class="but c-red" href="' . $url . '">查看订单</a>';
            }

            $del_link = '<a class="del_cardcode" delete-key="' . $key . '" post-id="' . $post_id . '" form-action="del_cardcode" href="">删除</a>';
            $del = '<div class="row-actions">' . $del_link . '</div>';
            $tbody .= $show_check ?  '<th scope="row" class="check-column"><input class="check-delete check-all-item" type="checkbox" name="delete[]" value="' . $key . '"></th>' : '';

            $tbody .= '<td>' . $value['code'] . $del . '</td>';
            $tbody .= '<td>' . $value['key'] . '</td>';
            $tbody .= '<td>' . $status . '</td>';
            $tbody .= '<td>' . $value['create_time'] . '</td>';
            $tbody .= '<td>' . $value['modified_time'] . '</td>';

            $tbody .= '</tr>';
        }
        $table .= '<tbody>' . $tbody . '</tbody>';
    }

    return $table;
}



function zib_cp_post_add_key($post_id = '')
{

    $html = '<div>';
    $html .= '<p><b>请复制您的卡密数据</b></p>';
    $html .= '<p>一行一个卡密，卡号和密码用英文逗号或者空格或----分割</p>';
    $html .= '<ajaxform class="ajax-form" ajax-url="' . admin_url("admin-ajax.php") . '">';
    $html .= '<textarea ajax-name="cardcode" style="width:100%;" rows="6"></textarea>';
    $html .= '';
    $html .= '<div class="ajax-notice"></div>';
    $html .= '<p><a href="javascript:;" class="but jb-yellow ajax-submit"><i class="fa fa-paper-plane-o"></i>确认提交</a></p>';
    $html .= '<input type="hidden" ajax-name="action" value="add_cardcode">';
    $html .= '<input type="hidden" ajax-name="post_id" value="' . $post_id . '">';
    $html .= '</ajaxform>';
    $html .= '</div>';

    return $html;
}
