<?php
/*
 * @Author: Qinver
 * @Url: zibll.com
 * @Date: 2021-01-23 13:01:32
 * @LastEditTime: 2021-01-25 12:54:57
 */

/**文章已经付费盒子 */
add_filter('zibpay_posts_paid_box', 'zib_cp_posts_paid_box', 10, 4);
function zib_cp_posts_paid_box($box, $pay_mate, $paid, $post_id = '')
{
    $post_id = $post_id ? $post_id : get_the_ID();
    return zib_cp_posts_pay_box($box, $pay_mate, $post_id, $paid);
}


//文章支付盒子
add_filter('zibpay_posts_pay_box', 'zib_cp_posts_pay_box', 10, 3);
function zib_cp_posts_pay_box($box, $pay_mate, $post_id, $paid = 0)
{

    $pay = array(
        'order_num' => '0125122644234986754',
        'pay_type' => 'alipay',
        'pay_price' => 66.6,
        'pay_num' =>  '000000111111',
        'other' => '',
    );

    // 更新订单状态
    //$order = ZibPay::payment_order($pay);

    $pay_mate = $pay_mate ? $pay_mate : get_post_meta($post_id, 'posts_zibpay', true);
    if (empty($pay_mate['pay_type']) || $pay_mate['pay_type'] != '7') return;

    $_thumb = zib_post_thumbnail('', 'fit-cover radius8');

    $order_type_name = zibpay_get_pay_type_name($pay_mate['pay_type']);
    $order_type_class = 'order-type-' . $pay_mate['pay_type'];

    $cuont = '';
    if (_pz('pay_show_paycount', true)) {
        global $wpdb;
        $cuont = $wpdb->get_var("SELECT COUNT(id) FROM $wpdb->zibpay_order where post_id=$post_id and status=1");
        $cuont = !empty($pay_mate['pay_cuont']) ? round($pay_mate['pay_cuont'], 0) + $cuont : $cuont;
        $cuont = $cuont > 0 ? $cuont : 0;
        $cuont = '<span class="pay-cuont badg c-green hollow">已售 ' . $cuont . '</span>';
    }

    $cp_count = zib_cp::count($post_id, 'valid');
    $cuont .= '<span class="pay-cuont badg c-red hollow">库存 ' . $cp_count . '</span>';

    $mark = _pz('pay_mark', '￥');
    $mark = '<span class="pay-mark">' . $mark . '</span>';

    $order_name = get_bloginfo('name') . '-虚拟商品';
    $price = round($pay_mate['pay_price'], 2);

    $price_con = $mark . $price;
    //会员价格
    $vip_price = zibpay_get_posts_vip_price($pay_mate);
    $vip_price = $vip_price ? '<dd class="pay-box-price">' . $vip_price . '</dd>' : '';

    // 推荐返佣、让利功能
    if (_pz('pay_rebate_s')) {
        $referrer_id = zibpay_get_referrer_id();
        if ($referrer_id) {
            //查询到推荐人
            //返利规则
            $rebate_ratio = zibpay_get_user_rebate_rule($referrer_id);
            if (
                !empty($pay_mate['pay_rebate_discount'])
                && $rebate_ratio['type']
                && is_array($rebate_ratio['type'])
                && (in_array('all', $rebate_ratio['type']) || in_array($pay_mate['pay_type'], $rebate_ratio['type']))
            ) {
                // 设置标签文案
                $referrer_data = get_userdata($referrer_id);
                $discount_tag = _pz('pay_rebate_text_discount');
                $discount_tag =  str_replace('%discount%', $pay_mate['pay_rebate_discount'], $discount_tag);
                $discount_tag =  str_replace('%referrer_name%', $referrer_data->display_name, $discount_tag);
                $vip_price .= '<dt class="pay-box-price"><span class="badg jb-red px12">' . $discount_tag . '</span></dt>';
            };
        }
    }

    $original_price = empty($pay_mate['pay_original_price']) ? '' : $pay_mate['pay_original_price'];
    if ($original_price) {
        $original_price = '<span class="original-price mr10">' . $mark . $original_price . '</span>';
    }

    $pay_wechat_sdk = _pz('pay_wechat_sdk_options');
    $pay_alipay_sdk = _pz('pay_alipay_sdk_options');

    $posts_title = get_the_title() . get_the_subtitle(false);
    $pay_title = !empty($pay_mate['pay_title']) ? $pay_mate['pay_title'] : $posts_title;

    $pay_doc = !empty($pay_mate['pay_doc']) ? $pay_mate['pay_doc'] : '此内容为' . $order_type_name . '，请付费后获取卡密信息';

    $pay_details = !empty($pay_mate['pay_details']) ? '<div class="pay-details">' . $pay_mate['pay_details'] . '</div>' : '';

    $pay_button = zibpay_get_pay_form_but();

    //变化：必须登录
    $user_id = get_current_user_id();
    if (!$user_id) {
        if (zib_is_close_sign()) {
            $pay_button = '<span class="badg px12 c-yellow-2">登录功能已关闭，暂时无法购买，请与站长联系</span>';
        } else {
            $pay_button = '<a href="javascript:;" class="but jb-blue signin-loader ml10 mr6"><i class="fa fa-angle-right mr6" aria-hidden="true"></i>登录购买</a>';
        }
    }

    if ((!$pay_wechat_sdk || $pay_wechat_sdk == 'null') && (!$pay_alipay_sdk || $pay_alipay_sdk == 'null')) {
        $pay_button = '<span class="badg px12 c-yellow-2">暂时无法购买，请与站长联系</span>';
        if (is_super_admin()) {
            $pay_button = '<a href="' . zib_get_admin_csf_url('商城付费') . '" class="but c-red mr6">请先配置收款方式！</a>';
        }
    }

    if ($cp_count < 1) {
        //如果库存为0,则停止购买
        $pay_button = '<span class="badg em09 mr6 c-red">商品已售罄</span>';
        if (is_super_admin()) {
            $pay_button = '<a href="' . get_edit_post_link($post_id) . '" class="but em09 c-red mr6">商品已售罄，请添加卡密库存</a>';
        }
    }

    $user_cp = '';
    $pay_extra_hide = '';
    if ($user_id && $paid) {
        $user_cp =  zib_cp_post_cp_tab($user_id, $post_id);

        $user_cp = $user_cp ? $user_cp : '';
        $pay_extra_hide = !empty($pay_mate['pay_extra_hide']) ? '<div class="pay-extra-hide">' . $pay_mate['pay_extra_hide'] . '</div>' : '';
    }


    $con = '<div class="zib-widget pay-box ' . $order_type_class . '" id="posts-pay">
        <div class="pay-tag abs-center">
        ' . $order_type_name . '
        </div>
        <form class="pay-form">
						<ul class="list-inline">
						    <li>
						        <div class="pay-thumbnail">
						            ' . $_thumb . '
						        </div>
						    </li>
						    <li>
						        <dl>
						        <dt class="">' . $pay_title . '</dt>
                                <dt class="pay-box-price">' . $original_price . $price_con . $cuont . '</dt>
                                ' . $vip_price . '
						        <dd class="meta-time em09 muted-2-color">' . $pay_doc . '</dd>
						        </dl>
						    </li>
                        </ul>
						    <div class="pay-button">
						   		 ' . $pay_button . '
                            </div>
                            ' . $pay_details .  $pay_extra_hide . $user_cp . '
            <input type="hidden" name="post_id" value="' . $post_id . '">
            <input type="hidden" name="order_name" value="' . $order_name . '">
            <input type="hidden" name="order_type" value="' . $pay_mate['pay_type'] . '">
            <input type="hidden" name="action" value="initiate_pay">
        </form>
    </div>';
    return $con;
}


function zib_cp_post_cp_tab($user_id, $post_id = 0)
{

    $ajax_arg = array(
        'action' => 'post_user_cardcode',
        'post_id' => $post_id,
    );
    $ajax_url = esc_url(add_query_arg($ajax_arg, admin_url('admin-ajax.php')));

    $ajax_loader = '<div class="mt10"> <i class="placeholder s1" style="width: 40%;height: 30px;"></i><i class="placeholder s1 ml10" style="width: 50%;height: 30px;"></i></div>';
    $ajax_loader = '<span class="post_ajax_loader" style="display: none;">' . $ajax_loader . $ajax_loader . $ajax_loader . '</span>';

    $count =  zib_cp::user_count($user_id, $post_id);
    $but = '';
    if ($count > 1) {
        $but = '<div class="muted-2-color">已购买<b class="badg badg-sm c-red">' . $count . '</b>个卡密<a style="font-size: 12px;padding: 0 10px;" class="ajax-next ajax-open but ml10" ajax-replace="true" href="' . $ajax_url . '"><i class="fa fa-angle-right mr3"></i> 加载全部</a></div>';
    }

    $new_cp = zib_cp_post_user_cardcode_lists($user_id, $post_id, 1, 1, false);
    $html = '';
    $html .= '<div class="padding-10 mt10">';
    $html .= '<div class="title-h-left">已购卡密</div>';
    $html .= '<div class="ajaxpager">';
    $html .= '<div class="ajax-pag">' . $but . '</div>';

    $html .= $new_cp;
    $html .= $ajax_loader;
    $html .= '</div>';
    $html .= '</div>';

    return $html;
}


function zib_cp_post_user_cardcode_lists($user_id = '', $post_id = 0, $paged = 1, $ice_perpage = 5, $show_next = true)
{
    if (!$user_id) $user_id = get_current_user_id();
    if (!$user_id) return;

    //准备查询参数
    $paged = !empty($_REQUEST['paged']) ? $_REQUEST['paged'] : $paged;
    $ice_perpage = !empty($_REQUEST['ice_perpage']) ? $_REQUEST['ice_perpage'] : $ice_perpage;
    $offset = $ice_perpage * ($paged - 1);
    $post_id = !empty($_REQUEST['post_id']) ? (int)$_REQUEST['post_id'] : $post_id;

    global $wpdb;
    $WHERE = "WHERE `status` = 1 and `order_type` = 7 and `user_id` = $user_id and `cardcode` is not null";
    if ($post_id) {
        $WHERE .= " and `post_id` = $post_id";
    }
    $db_order = $wpdb->get_results("SELECT * FROM $wpdb->zibpay_order $WHERE order by pay_time DESC limit $offset,$ice_perpage");

    $lists = '';
    if ($db_order) {
        $mark = _pz('pay_mark', '￥');
        $count_all =  $wpdb->get_var("SELECT COUNT(user_id) FROM $wpdb->zibpay_order $WHERE");;

        foreach ($db_order as $order) {
            $cp_data = maybe_unserialize($order->cardcode);
            if (!empty($cp_data['code'])) {
                $cp_data = zib_cp::map($cp_data);
                $cp_code = '<b data-clipboard-text="' . $cp_data['code'] . '" class="but c-blue clip-aut mr10 mb6">卡号：' . $cp_data['code'] . '</b>';
                $cp_key = $cp_data['key'] ? '<b data-clipboard-text="' . $cp_data['key'] . '" class="but c-red clip-aut mb6">卡密：' . $cp_data['key'] . '</b>' : '';

                $order_num = $order->order_num;
                $order_price = $order->order_price;
                $pay_price = $order->pay_price;
                $pay_time = $order->pay_time;

                $pay_doc = '<span class="pull-right em12">' . $mark . $pay_price . '</span>';
                $pay_doc .= '订单时间：' . $pay_time;
                $pay_num = '订单号：' . $order_num;

                $lists .= '<div class="ajax-item border-bottom padding-h10">';
                $lists .=  $cp_code . $cp_key;
                $lists .= '<div class="meta-time em09 muted-2-color">' . $pay_num . '</div>';
                $lists .= '<dd class="meta-time em09 muted-2-color">' . $pay_doc . '</dd>';
                $lists .= '</div>';
            }
        }

        // 显示下一页按钮
        $ajax_arg = array(
            'action' => 'post_user_cardcode',
            'post_id' => $post_id,
        );

        $ajax_url = esc_url(add_query_arg($ajax_arg, admin_url('admin-ajax.php')));

        $lists .= $show_next ? zib_get_ajax_next_paginate($count_all, $paged, $ice_perpage, $ajax_url) : '';
    } else {
        $lists .= zib_get_ajax_null('暂无卡密订单', 40, 'null-order.svg');
    }

    $html = $lists;
    return $html;
}
