<?php
/*
 * @Author: Qinver
 * @Url: zibll.com
 * @Date: 2021-01-23 13:01:32
 * @LastEditTime: 2021-01-25 13:42:49
 */


/**挂钩到用户中心 */

add_action('author_info_tab', 'zib_cp_user_info_tab_cardcode', 11);
add_action('author_info_tab_con', 'zib_cp_user_info_tab_cardcode_con', 11);


function zib_cp_user_info_tab_cardcode($user_id)
{
    echo '<li class=""><a class="muted-2-color but hollow" data-toggle="tab" data-ajax="" href="#author-tab-cardcode"><i class="fa fa-credit-card-alt hide-sm fa-fw" aria-hidden="true"></i>我的卡密</a></li>';
}
function zib_cp_user_info_tab_cardcode_con($user_id)
{
    $id = 'author-tab-cardcode';
    $detail_ajax_href = esc_url(add_query_arg('action', 'author_tab_cardcode', admin_url('admin-ajax.php')));

    $count = zib_cp::user_count($user_id);
    $statistical = '';
    $statistical .= '<div class="row">';
    $statistical .= '<div class="col-sm-6"><div class="zib-widget jb-blue relative-h">';
    $statistical .= '<div class="absolute jb-blue radius" style=" height: 150%; left: 50%; opacity: 0.5; top: 50%; width: 60%; "></div><div class="absolute jb-blue radius" style=" height: 145%; left: -22%; opacity: .8; width: 89%; "></div>';

    $statistical .= '<div class="relative">';
    $statistical .= '<p class="opacity8"><i class="fa fa-credit-card-alt mr6" aria-hidden="true"></i>我的卡密</p>';

    $statistical .= '<div class="text-center"><span class="opacity8">共计</span><span style="font-size: 4em;">' . $count . '</span></div>';
    $statistical .= '</div>';

    $statistical .= '</div></div>';

    $statistical .= '</div>';

    $list = '';
    $list .= '<div class="title-h-left mb10"><b>卡密列表</b></div>';
    $list .= '<div class="ajaxpager">';
    $list .= '<span class="post_ajax_trigger"><a ajax-href="' . $detail_ajax_href . '" class="ajax_load ajax-next ajax-open"></a></span>';
    $placeholder = '<div class="padding-h10"><p class="placeholder t1"></p><h4 class="item-excerpt placeholder k1"></h4><p class="placeholder k2"></p><i class="placeholder s1"></i><i class="placeholder s1 ml10"></i></div>';
    $list .= '<div class="post_ajax_loader">' . $placeholder . $placeholder . $placeholder . '</div>';
    $list .= '</div>';

    $con = '<div class="tab-pane fade" id="' . $id . '">' . $statistical . $list . '</div>';
    echo $con;
    
}

function zib_cp_user_cardcode_lists($user_id = '', $paged = 1, $ice_perpage = 10)
{
    if (!$user_id) $user_id = get_current_user_id();
    if (!$user_id) return;

    //准备查询参数
    $paged = !empty($_REQUEST['paged']) ? $_REQUEST['paged'] : $paged;
    $ice_perpage = !empty($_REQUEST['ice_perpage']) ? $_REQUEST['ice_perpage'] : $ice_perpage;
    $offset = $ice_perpage * ($paged - 1);
    $post_id = !empty($_REQUEST['post_id']) ? (int)$_REQUEST['post_id'] : 0;

    global $wpdb;
    $WHERE = "WHERE `status` = 1 and `order_type` = 7 and `user_id` = $user_id and `cardcode` is not null";
    if ($post_id) {
        $WHERE .= " and `post_id` = $post_id";
    }
    $db_order = $wpdb->get_results("SELECT * FROM $wpdb->zibpay_order $WHERE order by pay_time DESC limit $offset,$ice_perpage");

    $lists = '';
    if ($db_order) {
        $mark = _pz('pay_mark', '￥');
        $count_all =  $wpdb->get_var("SELECT COUNT(user_id) FROM $wpdb->zibpay_order $WHERE");;
        $ajax_url = esc_url(add_query_arg('action', 'author_tab_cardcode', admin_url('admin-ajax.php')));

        foreach ($db_order as $order) {
            $cp_data = maybe_unserialize($order->cardcode);
            if (!empty($cp_data['code'])) {
                $cp_data = zib_cp::map($cp_data);
                $cp_code = '<b data-clipboard-text="' . $cp_data['code'] . '" class="but c-blue clip-aut mr10 mb6">卡号：' . $cp_data['code'] . '</b>';
                $cp_key = $cp_data['key'] ? '<b data-clipboard-text="' . $cp_data['key'] . '" class="but c-red clip-aut mb6">卡密：' . $cp_data['key'] . '</b>' : '';

                $order_num = $order->order_num;
                $order_price = $order->order_price;
                $pay_price = $order->pay_price;
                $pay_time = $order->pay_time;
                $post_id = $order->post_id;
                $pay_mate = get_post_meta($post_id, 'posts_zibpay', true);
                $order_price = !empty($pay_mate['pay_original_price']) ? $pay_mate['pay_original_price'] : $order_price;

                $posts_title = get_the_title($post_id);
                $pay_title = !empty($pay_mate['pay_title']) ? $pay_mate['pay_title'] : $posts_title;
                $pay_title = '<a class="but mr6 mb6" target="_blank" href="' . get_permalink($post_id) . '">' . $pay_title . '</a>';
                $pay_title .= '<a class="ajax-next ajax-open but mb6" ajax-replace="true" href="' . add_query_arg('post_id', $post_id, $ajax_url) . '">仅查看此商品<i class="fa fa-angle-right ml6"></i></a>';

                $pay_doc = '<span class="pull-right"><span class="pay-mark">价格：' . $mark . '</span>' . $order_price . '<span class="pay-mark ml10">实付金额：' . $mark . '</span>' . $pay_price . '</span>';
                $pay_doc .= '订单时间：' . $pay_time;
                $pay_num = '订单号：' . $order_num;

                $lists .= '<div class="ajax-item border-bottom padding-h10">';
                $lists .= '<div class="em09">' . $pay_title . '</div>';
                $lists .=  $cp_code . $cp_key;
                $lists .= '<div class="meta-time em09 muted-2-color">' . $pay_num . '</div>';
                $lists .= '<dd class="meta-time em09 muted-2-color">' . $pay_doc . '</dd>';
                $lists .= '</div>';
            }
        }

        // 显示下一页按钮
        if ($post_id) {
            $ajax_url = add_query_arg('post_id', $post_id, $ajax_url);
        }
        $lists .= zibpay_get_ajax_next_paging($count_all, $paged, $ice_perpage, $ajax_url);
    } else {
        $lists .= zib_get_ajax_null('暂无卡密订单', 40, 'null-order.svg');
    }

    $html = $lists;
    return $html;
}
